Ext.define('vimon.view.widget.Widget', {extend:'Ext.container.Container', alias:'widget.vimonWidget', mixins:['BpcCommon.mixin.Widget'], statics:{WIDGET_NAME:'VIMON', WIDGET_DESCRIPTION:'VIMON_WIDGET_DESCRIPTION', WIDGET_ICON_CLS:'x-fal fa-user-chart'}, layout:'card', activeItems:0, widgetConfigSettingMap:{moduleId:{settingType:'moduleInstance', '_label':'VIMON_SETTING_WIDGET_MODULE_ID'}}, initComponent:function() {
  Ext.log({msg:this.self.getName() + ': initComponent', level:'info'});
  this.initWidgetSettings();
  this.callParent();
  this.addContent();
  this.settingPanel = this.add({xtype:'bpcSettingPanel', settings:this.settingStore, buttons:[{text:'OK', handler:this.applySetting.bind(this)}]});
  this.initWidget();
}, applySetting:function() {
  this.addContent();
  this.setActiveItem(this.content);
}, addContent:function() {
  if (this.content) {
    this.remove(this.content);
  }
  this.content = this.add({xtype:'vimon', moduleId:this.getSetting('moduleId')});
}, refreshWidget:function() {
  this.addContent();
}, configureWidget:function() {
  Ext.log({msg:this.self.getName() + ': configureWidget', level:'info'});
  this.setActiveItem(this.settingPanel);
}});
Ext.define('vimon.BpcInterface', {extend:'BpcCommon.BpcInterface', requires:['vimon.view.widget.Widget'], config:{moduleConfigurationComponents:[], moduleInstanceConfigurationComponents:[], defaultModuleInstanceConfigurationComponent:undefined, widgets:['vimon.view.widget.Widget'], baseModuleView:null, mainView:null, forwardedEvents:[], css:false}});
Ext.define('vimon.Module', {singleton:true, constructor:function() {
  Ext.log('Loading VIMON Module...');
}});
Ext.define('vimon.view.Util', {singleton:true, getVimonUrl:function(moduleId) {
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'proxyId');
  var httpProxyUrl = BpcCommon.Api.getBackendUrl(proxyId);
  var initialDashboardPath = BpcCommon.Api.getSetting(moduleId, 'initialDashboardPath');
  var initialFilters = BpcCommon.Api.getSetting(moduleId, 'initialFilters');
  var orgId = BpcCommon.Api.getSetting(moduleId, 'orgId');
  var lowerDate = BpcCommon.Api.getSetting(moduleId, 'initialLowerDate');
  var upperDate = BpcCommon.Api.getSetting(moduleId, 'initialUpperDate');
  var kioskMode = BpcCommon.Api.getSetting(moduleId, 'kioskMode');
  var filterParams = [];
  if (initialFilters) {
    Object.entries(initialFilters).forEach(function(element) {
      var filterName = element[0] || null;
      var values = element[1] || null;
      if (Ext.isString(filterName)) {
        if (Ext.isArray(values)) {
          filterParams.push(values.map(function(item) {
            return filterName + '\x3d' + item;
          }).join('\x26'));
        } else if (Ext.isString(values) || Ext.isNumber(values)) {
          filterParams.push(filterName + '\x3d' + values);
        }
      }
    });
  }
  var filterURLParams = filterParams.join('\x26');
  var finalVimonUrl = '' + httpProxyUrl + initialDashboardPath + '?' + filterURLParams + '\x26from\x3d' + lowerDate + '\x26to\x3d' + upperDate + '\x26orgId\x3d' + orgId + '\x26kiosk\x3d' + kioskMode;
  return finalVimonUrl;
}});
Ext.define('vimon.view.Main', {extend:'Ext.container.Container', alias:'widget.vimon', layout:'fit', moduleId:undefined, initComponent:function() {
  var moduleId = this.moduleId;
  var proxyId = BpcCommon.Api.getSetting(moduleId, 'proxyId');
  if (!proxyId) {
    this.items = [{xtype:'panel', items:[{xtype:'component', html:'\n                     \x3ch1 style\x3d"text-align: center;"\x3e' + BpcCommon.Api.getTranslation('VIMON_PRODUCT_NAME') + '\x3c/h1\x3e\n                     \x3cp style\x3d"text-align: center;"\x3e' + BpcCommon.Api.getTranslation('VIMON_DESCRIPTION') + '\x3c/p\x3e\n                     \x3cp style\x3d"text-align: center;"\x3e' + BpcCommon.Api.getTranslation('VIMON_SALE') + '\x3c/p\x3e\n                  '}]}];
  } else {
    var finalVimonUrl = vimon.view.Util.getVimonUrl(moduleId);
    this.items = [{xtype:'component', iframe:true, autoEl:{tag:'iframe', src:finalVimonUrl}, listeners:{el:{load:this.removeLoader.bind(this)}}}];
    this.listeners = {afterrender:function(c) {
      c.getEl().mask(BpcCommon.Api.getTranslation('CORE_LOADING'));
    }};
  }
  this.callParent();
}, removeLoader:function() {
  this.getEl().unmask();
}});
